package com.gct.tools.etlcamelhuge.controller;

import com.alibaba.fastjson.JSONObject;
import com.gct.tools.etlcamelhuge.entity.BaseDataBody;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.omg.CORBA.IRObject;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.sql.DataSource;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * class name: BaseDataController
 *
 * @author gxt
 * @version 1.0
 * @since 2021/8/30 下午3:51 周一
 */
@RestController
@RequestMapping("/BaseData")
@Api(value = "BaseDataController",description = "基础数据操作controller")
public class BaseDataController {

    private JdbcTemplate jdbcTemplate;
    @Resource(name = "oracle")
    DataSource oracleDataSource;

    @Resource(name = "centralbase")
    DataSource baseDataSource;

    @PostMapping("/StatusDaily")
    @ApiOperation("从 A2 获取 数据插入到 centrlBase 中")
    public JSONObject saveDataToStatusDaily(@RequestBody BaseDataBody baseDataBody){
        JSONObject jsonObject = new JSONObject();
        long insertCount = 0;
        try {
            jdbcTemplate = new JdbcTemplate(oracleDataSource);
            String date = baseDataBody.getDate();
            String sql = "select  distinct jh,rq,cyfs,yz,hysx , yysx ,tysx,bs,dym from DBA01 where rq  = to_date('"+date+"','yyyy-MM-dd') and qyrq is not null ";
            List<Map<String, Object>> list = jdbcTemplate.queryForList(sql);
            for (Map<String, Object> map : list) {
                if (map.get("YZ") == null) map.put("YZ", "0.0");
                if (map.get("HYSX") == null) map.put("HYSX", "0.0");
                if (map.get("YYSX") == null) map.put("YYSX", "0.0");
                if (map.get("TYSX") == null) map.put("TYSX", "0.0");
                if (map.get("BS") == null) map.put("BS", "0.0");
                sql = "insert into centralbase.cb_pc_pro_wellbore_status_daily(well_id,prod_date,oil_prod_method,oil_nozzle,back_pres,tubing_pres,casing_pres,pump_depth) " +
                        "value (?,?,?,?,?,?,?,?)";
                int count = insertBaseDataSourceOfStatusDaily(sql, map);
                List<Map<String, Object>> dymIsNotNUllList = selectA2DataOfNotIsNullDYM();
                for (Map<String, Object> stringObjectMap : dymIsNotNUllList) {
                    sql = "update centralbase.cb_pc_pro_wellbore_status_daily set start_pump_liq_level = '"+stringObjectMap.get("DYM")+"' where well_id = '"+stringObjectMap.get("JH")+"' and prod_date::date  = '"+stringObjectMap.get("RQ")+"' ";
                    int dymIsNotNullCount = updateBaseDataSourceOfStatusDaily(sql);
                    insertCount = insertCount + dymIsNotNullCount;
                }
                sql = "select well_id,prod_date,start_pump_liq_level,pump_depth from centralbase.cb_pc_pro_wellbore_status_daily where prod_date = '"+map.get("RQ")+"' ";
                List<Map<String, Object>> CMDDataList = selectBaseDataSourceStatusDaily(sql);
                for (Map<String, Object> stringObjectMap : CMDDataList) {
                    stringObjectMap.put("submergence_depth",null);
                    if (stringObjectMap.get("start_pump_liq_level")!=null && stringObjectMap.get("pump_depth")!=null){
                        double cmd= Double.valueOf(stringObjectMap.get("pump_depth").toString())-Double.valueOf(stringObjectMap.get("start_pump_liq_level").toString())/10;
                        BigDecimal bd=new BigDecimal(cmd);
                        double cmd1=bd.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
                        stringObjectMap.put("submergence_depth",cmd1);
                    }
                    sql = " update centralbase.cb_pc_pro_wellbore_status_daily set submergence_depth = '"+stringObjectMap.get("submergence_depth")+"' where well_id = '"+stringObjectMap.get("well_id")+"' and prod_date  = '"+stringObjectMap.get("prod_date")+"' ";
                    int CMDUpdateCount = updateBaseDataSourceOfStatusDaily(sql);
                    insertCount = insertCount + CMDUpdateCount;
                }
                sql = " select distinct rn.well_id,cb.prod_date,rn.pump_diameter  from centralbase.cb_temp_well_mech_runtime rn ,centralbase.cb_pc_pro_wellbore_status_daily cb where cb.well_id = rn.well_id " +
                        " and cb.prod_date = '"+date+"'  ";
                List<Map<String, Object>> oilNozzleList = selectBaseDataSourceStatusDaily(sql);
                for (Map<String, Object> stringObjectMap : oilNozzleList) {
                    sql = " update centralbase.cb_pc_pro_wellbore_status_daily set oil_nozzle = '"+stringObjectMap.get("pump_diameter")+"' where well_id ='"+stringObjectMap.get("well_id")+"' and prod_date='"+stringObjectMap.get("prod_date")+"' ";
                    int oliNozzle = updateBaseDataSourceOfStatusDaily(sql);
                    insertCount = insertCount + oliNozzle;
                }
            }
        }catch (Exception e){
            e.printStackTrace();
            jsonObject.put("error",e.getMessage());
        }finally {
            jsonObject.put("插入条数",insertCount);
        }
        return jsonObject;
    }


    public int insertBaseDataSourceOfStatusDaily(String sql,Map<String,Object> map){
        jdbcTemplate = new JdbcTemplate(baseDataSource);
        if (map.isEmpty()) return 0;
        return  jdbcTemplate.update(sql, map.get("JH"), map.get("RQ"), map.get("CYFS"), map.get("YZ"), map.get("HYSX"), map.get("YYSX"), map.get("BS"), map.get("DYM"));
    }

    public List<Map<String, Object>> selectA2DataOfNotIsNullDYM(){
        jdbcTemplate = new JdbcTemplate(oracleDataSource);
        String sql = "SELECT  distinct jh,max(rq),dym FROM DBA01 WHERE dym is not null group by jh,dym";
        return  jdbcTemplate.queryForList(sql);
    }

    public List<Map<String, Object>> selectBaseDataSourceStatusDaily(String sql){
        jdbcTemplate = new JdbcTemplate(baseDataSource);
         return  jdbcTemplate.queryForList(sql);
    }
    public int updateBaseDataSourceOfStatusDaily(String sql){
        jdbcTemplate = new JdbcTemplate(baseDataSource);
        return  jdbcTemplate.update(sql);
    }

}
